"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = decodeDataUri;

var _toArrayBuffer = require("./to-array-buffer.node");

function decodeDataUri(uri) {
  var dataIndex = uri.indexOf(',');
  var buffer;
  var mimeType;

  if (uri.slice(dataIndex - 7, dataIndex) === ';base64') {
    buffer = new Buffer(uri.slice(dataIndex + 1), 'base64');
    mimeType = uri.slice(5, dataIndex - 7).trim();
  } else {
    buffer = new Buffer(decodeURIComponent(uri.slice(dataIndex + 1)));
    mimeType = uri.slice(5, dataIndex).trim();
  }

  if (!mimeType) {
    mimeType = 'text/plain;charset=US-ASCII';
  } else if (mimeType[0] === ';') {
    mimeType = "text/plain".concat(mimeType);
  }

  return {
    arrayBuffer: (0, _toArrayBuffer.toArrayBuffer)(buffer),
    mimeType: mimeType
  };
}
//# sourceMappingURL=decode-data-uri.node.js.map