"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _globals = require("./utils/globals");

var _encoding = require("./text-encoding/encoding");

var base64 = _interopRequireWildcard(require("./text-encoding/btoa.node"));

var _headers = _interopRequireDefault(require("./fetch-node/headers.node"));

var _response = _interopRequireDefault(require("./fetch-node/response.node"));

var _fetch = _interopRequireDefault(require("./fetch-node/fetch.node"));

var _encodeImage = require("./images-node/encode-image.node");

var _parseImage = require("./images-node/parse-image.node");

if (!('TextEncoder' in _globals.global) && _encoding.TextEncoder) {
  _globals.global['TextEncoder'] = _encoding.TextEncoder;
}

if (!('TextDecoder' in _globals.global) && _encoding.TextDecoder) {
  _globals.global['TextDecoder'] = _encoding.TextDecoder;
}

if (!_globals.isBrowser && !('atob' in _globals.global) && base64.atob) {
  _globals.global['atob'] = base64.atob;
}

if (!_globals.isBrowser && !('btoa' in _globals.global) && base64.btoa) {
  _globals.global['btoa'] = base64.btoa;
}

if (!_globals.isBrowser && !('Headers' in _globals.global) && _headers["default"]) {
  _globals.global['Headers'] = _headers["default"];
}

if (!_globals.isBrowser && !('Response' in _globals.global) && _response["default"]) {
  _globals.global['Response'] = _response["default"];
}

if (!_globals.isBrowser && !('fetch' in _globals.global) && _fetch["default"]) {
  _globals.global['fetch'] = _fetch["default"];
}

if (!_globals.isBrowser && !('_encodeImageNode' in _globals.global) && _encodeImage.encodeImageNode) {
  _globals.global['_encodeImageNode'] = _encodeImage.encodeImageNode;
}

if (!_globals.isBrowser && !('_parseImageNode' in _globals.global) && _parseImage.parseImageNode) {
  _globals.global['_parseImageNode'] = _parseImage.parseImageNode;
}
//# sourceMappingURL=index.js.map