import assert from '../../utils/assert';

const isArrayBuffer = x => x && x instanceof ArrayBuffer;

const isBuffer = x => x && x instanceof Buffer;

export function toArrayBuffer(data) {
  if (isArrayBuffer(data)) {
    return data;
  }

  if (isBuffer(data)) {
    const typedArray = new Uint8Array(data);
    return typedArray.buffer;
  }

  if (ArrayBuffer.isView(data)) {
    return data.buffer;
  }

  if (typeof data === 'string') {
    const text = data;
    const uint8Array = new TextEncoder().encode(text);
    return uint8Array.buffer;
  }

  return assert(false);
}
//# sourceMappingURL=to-array-buffer.node.js.map